#ifndef __BUF_H
#define __BUF_H
#include "gen.h"

#define O_BUFFER 0x100000

typedef struct _functionmap
	{
	FD (*open)(char *, Oflag, Mode);
	int (*close)(FD);
	srsize_t (*read)(FD, char *, size_t);
	swsize_t (*write)(FD, char *, size_t);
	Seek (*seek)(FD, Seek, int);
	} Functionmap;

extern Functionmap filebufmap;

typedef FD BFD;

BFD bopen(char *path, Oflag oflag, Mode pmode, Functionmap *map);
void allflush(void);
BFD bufferset(FD fd, Functionmap *map);
BFD bset(FD fd, Functionmap *map);
FD bfd_to_fd(BFD bfd);
int buffer(BFD bfd);
BFD bcreat(char *path, Mode pmode, Functionmap *map);
Seek bseek(BFD bfd, Seek seek, int whence);
int bunset(BFD bfd);
int bclose(BFD bfd);
int unbuffer(BFD bfd);
int flush(BFD bfd);
int bread(BFD bfd, void *buf, unsigned int nbyte);
int bwrite(BFD bfd, void *buf, unsigned int nbyte);

#endif
