#ifndef gen_h
#define gen_h
#include <sys/types.h>
#include "porttypes.h"
#include "assert.h"

/* constants
 */
#define ALWAYS
#define YES 1
#define NO 0
#define ERROR -1
#define EOS '\0'
#define LOBYTE 		0xFF
#define HIBYTE 		0xFF00
#define EQUAL 	0 /* for use with strcmp */

#define ROOTUID 0
#define ROOTGID 0
/* rsetjmp init rtn
 */
#define JMPINIT 0
#define RJMPINIT -1
/* exit codes
 */
#define E_SUCCESS 0
#define E_FAIL 1
#define E_USAGE 2
#define E_INTERN 3
#define E_SIGNAL 4
#define E_STARTNUM 10

#define PATHSIZE 255 /* Maximum length of a path */
#define NAMESIZE 127 /* maximum length of a file name */

/* macros
 */
#ifdef EINTR
#define ERRNO (0 < errno ? errno : EINTR)
#else
#define ERRNO (0 < errno ? errno : 4)
#endif

/* typedefs
 */
typedef Uint16 Sbool;
#define portSbool portUint16
typedef int FD;
typedef Sint32 Seek;
#define portSeek portSint32
typedef int Oflag;
typedef int Mode;
#define NOSEEK -1
#ifndef max
#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))
#endif

#include <sys/stat.h>
#include <sys/vfs.h>
typedef struct stat Stat;
typedef struct statfs Statfs;

/* externs
 */
extern char *progname;
extern char const * const sys_errlist[];
extern Bool interrupted;
extern void interrupt(void);

/* prototypes
 */
char *dirname(char *buf, char *path);
char *t_basename(char *buf, char *path);
#ifndef VAR_SRC
int errfmt(char *fmt, ...);
void errexit(int cerrno, char *fmt, ...);
int failure(int cerrno, char *fmt, ...);
#endif
char *xmktemp(char *);
#if defined(sparc)
#define lint 1
#include <stdarg.h>
#define VAR_ARGS int va0, int va1, int va2, int va3, int va4, int va5, int va6, int va7, int va8, int va9
#else
#include <stdarg.h>
#define VAR_ARGS ...
#endif

#include "sysdep.h"

#endif /* gen_h */
